# -*- coding:utf-8 -*-
#---------------------------------------------------------------------
#
# Visor Geogrfico
# Copyright (C) 2009 Germn Carrilo (GeoTux)
#
#---------------------------------------------------------------------
#
# licensed under the terms of GNU GPL 2
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software. If not, see <http://www.gnu.org/licenses/>.
#
#---------------------------------------------------------------------


from PyQt4.QtSql import QSqlDatabase, QSqlQuery

class ConexionPgSQL():
    """ Provee los mtodos para conectarse a PostgreSQL/PostGIS """
    def __init__( self, servidor, puerto, bd, usuario, contrasena ):

        # Destruir el objeto si ya existe. Se usa el mtodo esttico.
        if QSqlDatabase.contains( "midb" ):
            QSqlDatabase.removeDatabase( "midb" )

        # Paramentros conexion
        self.db = QSqlDatabase.addDatabase( "QPSQL", "midb" )
        self.db.setHostName( servidor )
        self.db.setPort( int( puerto ) )
        self.db.setDatabaseName( bd )
        self.db.setUserName( usuario )
        self.db.setPassword( contrasena )

        self.query = QSqlQuery( self.db ) # Inicializar objeto query

    def conectar( self ):
        conectado = self.db.open()
        return conectado

    def consultarRegistro( self, consulta ):
        if self.query.exec_( consulta ):
            print "Por implementar"
        else:
            # La consulta est mal
            print "Por implementar"

    def consultarCapas( self ):
        """
            Retorna un arreglo de datos con la informacin de la tabla
            geometry_columns de PostGIS
        """
        if self.query.exec_( "SELECT f_table_schema, f_table_name, " \
            + "f_geometry_column, type FROM public.geometry_columns" ):
            record = self.query.record()
            posEsquema = record.indexOf( "f_table_schema" )
            posTabla = record.indexOf( "f_table_name" )
            posGeom = record.indexOf( "f_geometry_column" )
            posType = record.indexOf( "type" )

            aTabla = []

            while self.query.next():
                esquema = self.query.value( posEsquema ).toString()
                tabla = self.query.value( posTabla ).toString()
                geom = self.query.value( posGeom ).toString()
                tipo = self.query.value( posType ).toString()

                aDatos = [ esquema, tabla, geom, tipo ]
                aTabla.append( aDatos )

            return aTabla

        else:
            return None
